/* Problem URL: https://codeforces.com/gym/106159/problem/N */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    ll d, tmpy;
    cin >> d >> tmpy;
    __int128 y = tmpy;

    int size = 62;
    V<__int128> mov(size);
    mov[0] = 0;
    mov[1] = 1;
    mov[2] = 3;
    nrep(i, 3, size) {
        mov[i] = mov[i - 1] * 2;
    }

    V<__int128> pref(size + 1);
    rep(i, size) {
        pref[i + 1] = pref[i] + mov[i];
    }

    int low = 0;
    int high = size;
    int an = -1;
    while (low <= high) {
        int mid = (low + high) >> 1;

        if (pref[mid] >= d) {
            an = mid;
            high = mid - 1;
            continue;
        }

        low = mid + 1;
    }

    int now = ~an & 1;
    __int128 cost = d - pref[an - 1];
    __int128 x = y + cost * (now ? -1 : 1);
    now ^= 1;
    an--;
    while (an-- > 0) {
        __int128 next = x + mov[an] * (now ? -1 : 1);
        if ((y >= x && y <= next) || (y >= next && y <= x)) {
            cout << "Nao\n";
            return;
        }
        x = next;
        now ^= 1;
    }

    string ans;
    if (x == 0) {
        ans = "0";
    } else {
        bool neg = false;
        if (x < 0) {
            x = -x;
            neg = true;
        }
        while (x > 0) {
            ans.push_back(x % 10 + '0');
            x /= 10;
        }
        if (neg) {
            ans.push_back('-');
        }
    }
    reverse(all(ans));

    cout << "Sim\n" << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
